// ------------------------------------------------------------------------------
// PythagorasTree - http://www.arkitus.com
// Copyright (C) 2005  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// PythagorasTree.java
// Procedures related to starting up the program and adjusting the settings
// are in this file.
// ------------------------------------------------------------------------------

// Current number of shapes
int numc = 0;

// Total number of shapes
int numt = 1;

// Maximum number of possible squares and
// triangles in the array. Back then I didn't
// know how to use arrayLists.
Shape[] shapes = new Shape[10000];

void setup()
{
  size(800,420);
  framerate(20);
  smooth();
  fill(230,230,230);
  stroke(0,0,0);
  strokeWeight(1);
  shapes[0] = new Shape(365, 300, 435, 300);
}

void draw()
{
  background(255,255,255); 
  
  // Draw the base square...
  beginShape(POLYGON);
  vertex(365,350);
  vertex(435,350);
  vertex(435,300);
  vertex(365,300);
  endShape();
  
  // Then recursively draw the
  // rest.
  for ( int i=0; i<numc; i++ )
  {
    shapes[i].recalculate();
    shapes[i].display();
  }
}

void mouseReleased()
{
  for ( int i=0; i<numt; i++ )
  {
    if ( numt < 100 )
    {
      shapes[i].canAddChild = true;
      shapes[i].addChildren();
    }
  }
  
  numt = numc;
}
